local SpecSwap = {}

SpecSwap.Version = 1.4;
SpecSwap.VersionBroadcast = 1;
SpecSwap.CurrentGearSet = nil;

-- Bindings.xml Variables
BINDING_HEADER_SpecSwap_Header = "SpecSwap";
BINDING_NAME_SpecSwap_FirstSpec = "Swap to First Spec";
BINDING_NAME_SpecSwap_SecondSpec = "Swap to Second Spec";
BINDING_NAME_SpecSwap_ThirdSpec = "Swap to Third Spec";
BINDING_NAME_SpecSwap_FourthSpec = "Swap to Fourth Spec";
BINDING_NAME_SpecSwap_Naked = "Equip Naked Set";

function SpecSwap:Log(msg)
	if (nil == msg) then
		return;
	end

	DEFAULT_CHAT_FRAME:AddMessage(string.format("|cff33ff99SS:|cffffff78 %s", msg));
end

function SpecSwap:Initialize()
	if (1 == SpecSwap.VersionBroadcast) then
		SpecSwap.VersionBroadcast = 0;
		SpecSwap:Log(string.format("SpecSwap version %s loaded.", SpecSwap.Version));
	end
	
	if (nil == SpecSwap.CurrentGearSet) then
		SpecSwap.CurrentGearSet = SpecSwap_GetSpecializationName(GetSpecialization());
	end
end

function SpecSwap:OnEvent(event, ...)	
	if ("ADDON_LOADED" == event) then
		SpecSwap:Initialize();
	end
	
	if ("ACTIVE_TALENT_GROUP_CHANGED" == event) then
		SpecSwap_SwapEquipment(GetSpecialization());
	end
end

function SpecSwap_GetSpecializationName(specIndex)
	if ((nil == specIndex) or (GetNumSpecializations() < specIndex)) then
		return "";
	else
		return string.sub(select(2, GetSpecializationInfo(specIndex)), 1, 16);
	end
end

function SpecSwap_SwapSpec(specIndex)
	if (InCombatLockdown()) then return end

	if (GetSpecialization() ~= specIndex) then
		SetSpecialization(specIndex);
	end
	
	--SpecSwap_SwapEquipment(specIndex);
end

function SpecSwap_SwapEquipment(specIndex)
	if (InCombatLockdown()) then return end
	
	--local down, up, lagHome, lagWorld = GetNetStats();
	--C_Timer.After(((lagHome + lagWorld) / 1000) + 3, function() UseEquipmentSet(SpecSwap_GetSpecializationName(specIndex)); end);
	-- if not select(3, GetEquipmentSetInfoByName(SpecSwap_GetSpecializationName(specIndex))) then

	if (SpecSwap_GetSpecializationName(GetSpecialization()) ~= SpecSwap.CurrentGearSet) then
		SpecSwap.CurrentGearSet = SpecSwap_GetSpecializationName(GetSpecialization());
		UseEquipmentSet(SpecSwap_GetSpecializationName(specIndex));
	end
end

function SpecSwap_FirstSpec()
	SpecSwap_SwapSpec(1);
end

function SpecSwap_SecondSpec()
	SpecSwap_SwapSpec(2);
end

function SpecSwap_ThirdSpec()
	SpecSwap_SwapSpec(3);
end

function SpecSwap_FourthSpec()
	SpecSwap_SwapSpec(4);
end

function SpecSwap_Naked()
	UseEquipmentSet("Naked");
end

SpecSwap.frame = CreateFrame("Frame");
SpecSwap.frame:SetScript("OnEvent", SpecSwap.OnEvent);
SpecSwap.frame:RegisterEvent("ADDON_LOADED");
SpecSwap.frame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
